/// @cond EO_CXX_EO_IMPL

inline void elm::panel::toggle() const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_panel_toggle());
}

inline Elm_Panel_Orient elm::panel::orient_get() const
{
   Elm_Panel_Orient _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_panel_orient_get());
   return _tmp_ret;
}

inline void elm::panel::orient_set(Elm_Panel_Orient orient_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_panel_orient_set(orient_));
}

inline bool elm::panel::hidden_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_panel_hidden_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::panel::hidden_set(bool hidden_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_panel_hidden_set(::efl::eolian::to_c(hidden_)));
}

inline bool elm::panel::scrollable_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_panel_scrollable_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::panel::scrollable_set(bool scrollable_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_panel_scrollable_set(::efl::eolian::to_c(scrollable_)));
}

inline void elm::panel::scrollable_content_size_set(double ratio_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_panel_scrollable_content_size_set(ratio_));
}

inline void eo_cxx::elm::panel::toggle() const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_panel_toggle());
}

inline Elm_Panel_Orient eo_cxx::elm::panel::orient_get() const
{
   Elm_Panel_Orient _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_panel_orient_get());
   return _tmp_ret;
}

inline void eo_cxx::elm::panel::orient_set(Elm_Panel_Orient orient_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_panel_orient_set(orient_));
}

inline bool eo_cxx::elm::panel::hidden_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_panel_hidden_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::panel::hidden_set(bool hidden_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_panel_hidden_set(::efl::eolian::to_c(hidden_)));
}

inline bool eo_cxx::elm::panel::scrollable_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_panel_scrollable_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::panel::scrollable_set(bool scrollable_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_panel_scrollable_set(::efl::eolian::to_c(scrollable_)));
}

inline void eo_cxx::elm::panel::scrollable_content_size_set(double ratio_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_panel_scrollable_content_size_set(ratio_));
}

inline ::eo_cxx::elm::panel::operator ::elm::panel() const
{
   return *static_cast<::elm::panel const*>(static_cast<void const*>(this));
}

inline ::eo_cxx::elm::panel::operator ::elm::panel&()
{
   return *static_cast<::elm::panel*>(static_cast<void*>(this));
}

inline ::eo_cxx::elm::panel::operator ::elm::panel const&() const
{
   return *static_cast<::elm::panel const*>(static_cast<void const*>(this));
}

template <typename T>
void elm_panel_toggle_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         static_cast<T*>(self->this_)->toggle();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
Elm_Panel_Orient elm_panel_orient_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->orient_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_Panel_Orient _tmp_ret{};
         return _tmp_ret;
      }
}

template <typename T>
void elm_panel_orient_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Elm_Panel_Orient orient_)
{
   try
      {
         static_cast<T*>(self->this_)->orient_set(orient_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
bool elm_panel_hidden_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->hidden_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_panel_hidden_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_Bool hidden_)
{
   try
      {
         static_cast<T*>(self->this_)->hidden_set(::efl::eolian::to_cxx<bool>(hidden_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
bool elm_panel_scrollable_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->scrollable_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_panel_scrollable_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_Bool scrollable_)
{
   try
      {
         static_cast<T*>(self->this_)->scrollable_set(::efl::eolian::to_cxx<bool>(scrollable_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void elm_panel_scrollable_content_size_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, double ratio_)
{
   try
      {
         static_cast<T*>(self->this_)->scrollable_content_size_set(ratio_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm::panel >
{
   template <typename T>
   struct type
         : virtual operations< ::elm::layout >::template type<T>
         , virtual operations< ::elm_interface_scrollable >::template type<T>
         , virtual operations< ::elm_interface_atspi_widget_action >::template type<T>
   {
      virtual void toggle()
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_panel_toggle());
      }

      virtual Elm_Panel_Orient orient_get()
      {
         Elm_Panel_Orient _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_panel_orient_get());
            return _tmp_ret;
      }

      virtual void orient_set(Elm_Panel_Orient orient_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_panel_orient_set(orient_));
      }

      virtual bool hidden_get()
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_panel_hidden_get());
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void hidden_set(bool hidden_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_panel_hidden_set(::efl::eolian::to_c(hidden_)));
      }

      virtual bool scrollable_get()
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_panel_scrollable_get());
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void scrollable_set(bool scrollable_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_panel_scrollable_set(::efl::eolian::to_c(scrollable_)));
      }

      virtual void scrollable_content_size_set(double ratio_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_panel_scrollable_content_size_set(ratio_));
      }

   };
};


template<>
struct operation_description_class_size< ::elm::panel >
{
   static constexpr int value = 
#if defined(PANEL_PROTECTED) && defined(PANEL_BETA)
      8
#elif defined(PANEL_PROTECTED)
      8
#elif defined(PANEL_BETA)
      8
#else
      8
#endif
      + operation_description_class_size<::elm::layout >::value      + operation_description_class_size<::elm_interface_scrollable >::value      + operation_description_class_size<::elm_interface_atspi_widget_action >::value;
};

template <typename T>
int initialize_operation_description(::efl::eo::detail::tag<::elm::panel>
                                 , Eo_Op_Description* ops)
{
   int i = 0;
   (void)i;
   (void)ops;
   ops[i].func = reinterpret_cast<void*>(& ::elm_panel_toggle_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_panel_toggle);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_panel_orient_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_panel_orient_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_panel_orient_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_panel_orient_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_panel_hidden_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_panel_hidden_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_panel_hidden_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_panel_hidden_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_panel_scrollable_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_panel_scrollable_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_panel_scrollable_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_panel_scrollable_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_panel_scrollable_content_size_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_panel_scrollable_content_size_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   initialize_operation_description<T>(::efl::eo::detail::tag<::elm::layout>(), &ops[operation_description_class_size< ::elm::panel >::value]);
   initialize_operation_description<T>(::efl::eo::detail::tag<::elm_interface_scrollable>(), &ops[operation_description_class_size< ::elm::panel >::value + operation_description_class_size<::elm::layout>::value]);
   initialize_operation_description<T>(::efl::eo::detail::tag<::elm_interface_atspi_widget_action>(), &ops[operation_description_class_size< ::elm::panel >::value + operation_description_class_size<::elm::layout>::value + operation_description_class_size<::elm_interface_scrollable>::value]);
   return 0;
}
inline Eo_Class const* get_eo_class(tag<::elm::panel>)
{
   return (ELM_PANEL_CLASS);
}

} } }

/// @endcond

